
#define MaxFoldersCount (128)

#define Sound_Start(x) {}

// ----------------------------------------------------

#define chkdsk_MsgOfsY (8+(16*5))

static void chkdsk_ExeclusiveWaitForPressButton(void)
{
  u16 KEYS_CUR;
  
  KEYS_CUR=(~REG_KEYINPUT)&0x3ff;
  while(KEYS_CUR!=0){
    KEYS_CUR=(~REG_KEYINPUT)&0x3ff;
  }
  while(KEYS_CUR==0){
    KEYS_CUR=(~REG_KEYINPUT)&0x3ff;
  }
  while(KEYS_CUR!=0){
    KEYS_CUR=(~REG_KEYINPUT)&0x3ff;
  }
}

enum EFatalErrorType {EFET_DuplicatedArea,EFET_BrokenEntry,EFET_IlligalClusterLink,EFET_BrokenDirectoryLink,EFET_BrokenUnicode,EFET_FileSizeError,EFET_OverCluster};

static void chkdsk_DuplicateCluster_ShowFatalError(EFatalErrorType FatalErrorType)
{
  CglCanvas *pCanvas=pScreenMain->pCanvas;
  
  pCanvas->FillFull(GlobalBGColor15);
  
  u32 x=8,y=8;
  
  pCanvas->TextOutUTF8(x,y,"!! ディスクに致命的なエラーを発見しました !!");
  y+=16;
  y+=16;
  switch(FatalErrorType){
    case EFET_DuplicatedArea: {
      pCanvas->TextOutUTF8(x,y,"複数のファイルが重なった領域を使用しています。");
      y+=16;
      pCanvas->TextOutUTF8(x,y,"いくつかのファイルは既に破壊されています。");
      y+=16;
    } break;
    case EFET_BrokenEntry: {
      pCanvas->TextOutUTF8(x,y,"ディレクトリエントリが異常です。");
      y+=16;
      pCanvas->TextOutUTF8(x,y,"一つ以上のファイルが破損しています。");
      y+=16;
    } break;
    case EFET_IlligalClusterLink: {
      pCanvas->TextOutUTF8(x,y,"クラスタリンクが規格外で途切れました。");
      y+=16;
      pCanvas->TextOutUTF8(x,y,"ファイルが破損している可能性があります。");
      y+=16;
    } break;
    case EFET_BrokenDirectoryLink: {
      pCanvas->TextOutUTF8(x,y,"ディレクトリエントリが異常です。");
      y+=16;
      pCanvas->TextOutUTF8(x,y,"フォルダが破壊されています。");
      y+=16;
    } break;
    case EFET_BrokenUnicode: {
      pCanvas->TextOutUTF8(x,y,"ディレクトリエントリが異常です。");
      y+=16;
      pCanvas->TextOutUTF8(x,y,"長いファイル名が破壊されています。");
      y+=16;
    } break;
    case EFET_FileSizeError: {
      pCanvas->TextOutUTF8(x,y,"ディレクトリエントリが示すサイズと、");
      y+=16;
      pCanvas->TextOutUTF8(x,y,"実際のファイルサイズが違います。");
      y+=16;
    } break;
    case EFET_OverCluster: {
      pCanvas->TextOutUTF8(x,y,"実際のディスク容量を超えたクラスタに、");
      y+=16;
      pCanvas->TextOutUTF8(x,y,"保存されていると指示されたファイルがあります。");
      y+=16;
    } break;
    default: {
      pCanvas->TextOutUTF8(x,y,"未定義エラー");
      y+=16;
    } break;
  }
  y+=16;
  pCanvas->TextOutUTF8(x,y,"回復手段：");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"全てのファイルをHDDにバックアップして、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"フォーマット後にコピーし直して下さい。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"アプリケーションを停止しました。");
  
  Sound_Start(WAVFN_Notify);
  ShowLogHalt();
}

static void chkdsk_DuplicateCluster_ShowBufferOverflow(void)
{
  CglCanvas *pCanvas=pScreenMain->pCanvas;
  
  pCanvas->FillFull(GlobalBGColor15);
  
  u32 x=8,y=8;
  
  pCanvas->TextOutUTF8(x,y,"扱えないフォーマットのディスクです。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"ディスクサイズが大きすぎるか、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"クラスタサイズが小さすぎます。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"回復手段：");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"もっと大きなクラスタサイズで、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"フォーマットを試みて下さい。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"アプリケーションを停止しました。");
  
  Sound_Start(WAVFN_Notify);
  ShowLogHalt();
}

static void chkdsk_DuplicateCluster_ShowFragments(u32 fragmentfiles,u32 fragments)
{
  CglCanvas *pCanvas=pScreenMain->pCanvas;
  
  pCanvas->FillFull(GlobalBGColor15);
  
  u32 x=8,y=4;
  
  pCanvas->TextOutUTF8(x,y,"警告!! 断片化されたファイルを発見しました。");
  y+=16;
  {
    char str[256];
    snprintf(str,256,"%dファイルの内に、%d個の断片があります。",fragmentfiles,fragments);
    pCanvas->TextOutUTF8(x,y,str);
  }
  y+=16;
  y+=8;
  pCanvas->TextOutUTF8(x,y,"普通の自作アプリ系では問題ありませんが、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"読み込み速度にシビアなアプリやゲームでは、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"問題が発生する可能性があります。");
  y+=16;
  y+=8;
  pCanvas->TextOutUTF8(x,y,"もっとも普遍的な回避手段は、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"全てのファイルをHDDにバックアップして、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"フォーマット後にコピーし直すことだと思います。");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"Windowsのデフラグは絶対に使わないで下さい。");
  y+=16;
  y+=8;
  pCanvas->TextOutUTF8(x,y,"警告を無視するときは何かキーを押して下さい。");
  
  Sound_Start(WAVFN_Notify);
  chkdsk_ExeclusiveWaitForPressButton();
  pCanvas->FillFull(GlobalBGColor15);
}

// ----------------------------------------------------

/*
static u32 TotalFilesCount,CurrentFileIndex;

static void chkdsk_GetTotalFilesCount_ins(void)
{
  u32 FolderCount=0;
  char *pFolderNameAlias=(char*)safemalloc(MaxFilesCount*(12+1));
  
  if(pFolderNameAlias==NULL){
    _consolePrint("Fatal error. (pFolderNameAlias) Memory overflow.\n");
    ShowLogHalt();
    return;
  }
  
  {
    static const char *pafn;
    
    u32 FAT_FileType=FAT_FindFirstFile(&pafn);
    
    while(FAT_FileType!=FT_NONE){
      switch(FAT_FileType){
        case FT_NONE: break;
        case FT_DIR: {
          if((strcmp(pafn,".")!=0)&&(strcmp(pafn,"..")!=0)){
            strcpy(&pFolderNameAlias[FolderCount*(12+1)],pafn);
            FolderCount++;
          }
        } break;
        case FT_FILE: {
          TotalFilesCount++;
        } break;
      }
      
      FAT_FileType=FAT_FindNextFile(&pafn);
    }
  }
  
  for(u32 idx=0;idx<FolderCount;idx++){
    if(FAT_CWD(&pFolderNameAlias[idx*(12+1)])==false){
      _consolePrintf("FileSysterm: Fatal error. FAT_CWD(%s)==false.\n",&pFolderNameAlias[idx*(12+1)]);
      chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenDirectoryLink);
      return;
    }
    chkdsk_GetTotalFilesCount_ins();
    if(FAT_CWD("..")==false){
      _consolePrint("FileSysterm: Fatal error. FAT_CWD('..')==false.\n");
      chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenDirectoryLink);
      return;
    }
  }
  
  if(pFolderNameAlias!=NULL){
    safefree(pFolderNameAlias); pFolderNameAlias=NULL;
  }
}

static void chkdsk_GetTotalFilesCount(void)
{
  if(FAT_CWD("/")==false){
    _consolePrintf("FileSysterm: Fatal error. FAT_CWD('/')==false.\n");
    chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenDirectoryLink);
    return;
  }
  
  TotalFilesCount=0;
  CurrentFileIndex=0;
  chkdsk_GetTotalFilesCount_ins();
}
*/

// ----------------------------------------------------

static void chkdsk_DuplicateCluster_ShowProgress(float CurrentPer,u32 CheckedFilesCount)
{
  CglCanvas *pCanvas=pScreenMain->pCanvas;
  
  char str[64];
  
  snprintf(str,64,"progress... %d%% %dfiles",(u32)(CurrentPer*100),CheckedFilesCount);
  
  pCanvas->SetColor(GlobalBGColor15);
  pCanvas->FillBox(16,chkdsk_MsgOfsY+(16*2),ScreenWidth-16,16);
  pCanvas->TextOutA(16,chkdsk_MsgOfsY+(16*2),str);
}

static void chkdsk_DuplicateCluster_ClearProgress(void)
{
  CglCanvas *pCanvas=pScreenMain->pCanvas;
  
  pCanvas->SetColor(GlobalBGColor15);
  pCanvas->FillBox(16,chkdsk_MsgOfsY+(16*2),ScreenWidth-16,16);
}

static u32 ClusterFlagsCount;
static u32 *pClusterFlags;

static u32 FragmentFileCount,FragmentCount;

static void chkdsk_DuplicateCluster_Init(void)
{
  ClusterFlagsCount=FAT2_GetTotalClusterCount();
  
  _consolePrintf("Total cluster count = %d.\n",ClusterFlagsCount);
  
  u32 ClusterFlagsSize=((ClusterFlagsCount+31)/32)*4;
  pClusterFlags=(u32*)safemalloc(ClusterFlagsSize);
  
  if(pClusterFlags==NULL){
    _consolePrint("Fatal error. (pClusterFlags) Memory overflow.\n");
    ShowLogHalt();
    return;
  }
  
  MemSet32CPU(0,pClusterFlags,ClusterFlagsSize);
  
  FragmentFileCount=0;
  FragmentCount=0;
}

static void chkdsk_DuplicateCluster_SetFlag(u32 Cluster)
{
  if(ClusterFlagsCount<=Cluster){
    _consolePrintf("FileSysterm: Fatal error. Cluster check buffer overflow. %d<=%d\n",ClusterFlagsCount,Cluster);
    chkdsk_DuplicateCluster_ShowFatalError(EFET_OverCluster);
    return;
  }
  
  u32 flags=pClusterFlags[Cluster/32];
  
  u32 bit=1<<(Cluster&31);
  
  if((flags&bit)!=0){
    _consolePrint("FileSysterm: Fatal error. Duplicate cluster link finded.\n");
    chkdsk_DuplicateCluster_ShowFatalError(EFET_DuplicatedArea);
    return;
  }
  
  flags|=bit;
  
  pClusterFlags[Cluster/32]=flags;
}

static void chkdsk_DuplicateCluster_Free(void)
{
  if(pClusterFlags!=NULL){
    safefree(pClusterFlags); pClusterFlags=NULL;
  }
}

#define CLUSTER_FREE	0x0000
#define	CLUSTER_EOF	0x0FFFFFFF

static void chkdsk_DuplicateCluster_Current_FillUsedCluster(const char *pAlias)
{
  bool chkfragment=false;
  u32 fragment=0;
  
  u32 FileSize=FAT2_CurEntry_GetFileSize();
  
  u32 ClusterSize=FAT2_GetSecPerClus()*512;
  u32 UsedClusterCount=(FileSize+(ClusterSize-1))/ClusterSize;
  u32 ClusterCount=0;
  
  u32 CurClus=FAT2_GetFirstCluster();
  
  if((CurClus!=CLUSTER_FREE)&&(CurClus!=CLUSTER_EOF)){
    while(1){
      
      chkdsk_DuplicateCluster_SetFlag(CurClus);
      
      ClusterCount++;
      
      u32 NextClus=FAT2_NextCluster(CurClus);
      if(NextClus==CLUSTER_EOF) break;
      
      if((CurClus+1)!=NextClus) fragment++;
      
      CurClus=NextClus;
      
      if(CurClus==CLUSTER_FREE){
        _consolePrint("FileSysterm: Fatal error. Can not search cluster link.\n");
        chkdsk_DuplicateCluster_ShowFatalError(EFET_IlligalClusterLink);
        return;
      }
    }
  }
  
  if(fragment!=0){
    _consolePrintf("[%s] %dfragments.\n",pAlias,fragment);
    if(chkfragment==true){
      FragmentFileCount++;
      FragmentCount+=fragment;
    }
  }
  
  if(UsedClusterCount==0){
    if(ClusterCount==1) ClusterCount=0;
  }
  
  if(UsedClusterCount!=ClusterCount){
    _consolePrintf("[%s]\n",pAlias);
    _consolePrintf("Entry clusters: %d, Actual clusters:%d.\n",UsedClusterCount,ClusterCount);
    _consolePrint("A size that the directory entry shows and an actual size of the file are different.\n");
    chkdsk_DuplicateCluster_ShowFatalError(EFET_FileSizeError);
  }
}

static u32 CheckedFilesCount;

static void chkdsk_DuplicateCluster_ins(float CurrentPer,float DivPer)
{
  u32 FolderCount=0;
  char *pFolderNameAlias=(char*)safemalloc(MaxFoldersCount*(12+1));
  
  if(pFolderNameAlias==NULL){
    _consolePrint("Fatal error. (pFolderNameAlias) Memory overflow.\n");
    ShowLogHalt();
    return;
  }
  
  {
    static const char *pafn;
    static const UnicodeChar *pufn;
    
    u32 FAT_FileType=FAT2_FindFirstFile(&pafn);
    
    while(FAT_FileType!=FT_NONE){
      switch(FAT_FileType){
        case FT_NONE: break;
        case FT_DIR: {
          if((strcmp(pafn,".")!=0)&&(strcmp(pafn,"..")!=0)){
            pufn=FAT2_GetLongFilenameUnicode();
            if(pufn==NULL){
              _consolePrintf("FileSysterm: Fatal error. Unicode filename read error.\n Alias='%s'\n",pafn);
              chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenUnicode);
              return;
            }
            strcpy(&pFolderNameAlias[FolderCount*(12+1)],pafn);
            FolderCount++;
          }
        } break;
        case FT_FILE: {
          pufn=FAT2_GetLongFilenameUnicode();
          if(pufn==NULL){
            _consolePrintf("FileSysterm: Fatal error. Unicode filename read error.\n Alias='%s'\n",pafn);
            chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenUnicode);
            return;
          }
          chkdsk_DuplicateCluster_Current_FillUsedCluster(pafn);
          CheckedFilesCount++;
          if(6<=VBlankPassedCount){
            VBlankPassedCount=0;
            chkdsk_DuplicateCluster_ShowProgress(CurrentPer,CheckedFilesCount);
          }
        } break;
      }
      
      FAT_FileType=FAT2_FindNextFile(&pafn);
    }
  }
  
  DivPer/=FolderCount;
  
  for(u32 idx=0;idx<FolderCount;idx++){
    if(FAT2_chdir_Alias(&pFolderNameAlias[idx*(12+1)])==false){
      _consolePrintf("FileSysterm: Fatal error. FAT_CWD(%s)==false.\n",&pFolderNameAlias[idx*(12+1)]);
      chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenDirectoryLink);
      return;
    }
    chkdsk_DuplicateCluster_ins(CurrentPer,DivPer);
    CurrentPer+=DivPer;
    if(FAT2_chdir_Alias("..")==false){
      _consolePrint("FileSysterm: Fatal error. FAT_CWD('..')==false.\n");
      chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenDirectoryLink);
      return;
    }
  }
  
  if(pFolderNameAlias!=NULL){
    safefree(pFolderNameAlias); pFolderNameAlias=NULL;
  }
}

static void chkdsk_DuplicateCluster(void)
{
  {
    CglCanvas *pCanvas=pScreenMain->pCanvas;
    pCanvas->TextOutUTF8(16,chkdsk_MsgOfsY+(16*0),"重複クラスタと断片化を調べています。");
  }
  
  if(FAT2_chdir_Alias("/")==false){
    _consolePrintf("FileSysterm: Fatal error. FAT_CWD('/')==false.\n");
    chkdsk_DuplicateCluster_ShowFatalError(EFET_BrokenDirectoryLink);
    return;
  }
  
  chkdsk_DuplicateCluster_Init();
  
  CheckedFilesCount=0;
  chkdsk_DuplicateCluster_ins(0,1);
  
  chkdsk_DuplicateCluster_ClearProgress();
  
  if(FragmentCount!=0){
    _consolePrintf("%d fragment finded in %dfiles. (NDS/SAV)\n",FragmentCount,FragmentFileCount);
    if(256<FragmentCount){
      chkdsk_DuplicateCluster_ShowFragments(FragmentFileCount,FragmentCount);
    }
  }
  
  chkdsk_DuplicateCluster_Free();
}

// ----------------------------------------------------

static void chkdsk_CheckFATType(void)
{
  {
    CglCanvas *pCanvas=pScreenMain->pCanvas;
    pCanvas->TextOutUTF8(16,chkdsk_MsgOfsY+(16*2),"FATフォーマットを調査しています。");
  }
  
  u32 FATType=FAT2_GetFATType();
  
  if((FATType==16)||(FATType==32)) return;
  
  CglCanvas *pCanvas=pScreenMain->pCanvas;
  
  pCanvas->FillFull(GlobalBGColor15);
  
  u32 x=8,y=8;
  
  switch(FATType){
    case 12: case 16: case 32: {
      char str[256];
      snprintf(str,256,"FAT%dが検出されました。",FATType);
      pCanvas->TextOutUTF8(x,y,str);
      y+=16;
    } break;
    default: {
      pCanvas->TextOutUTF8(x,y,"認識できないFATフォーマットです。");
      y+=16;
    } break;
  }
  pCanvas->TextOutUTF8(x,y,"推奨されないFATフォーマットです。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"最近では問題が少なくなってきましたが、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"MoonlightはFAT16/32の使用を推奨します。");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"PanasonicのSDFormatterを強く推奨します。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"FAT32を使うときは特に頻繁に、");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"ディスクチェックを行うようにしてください。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"続行するときは何かキーを押して下さい。");
  
  Sound_Start(WAVFN_Notify);
  chkdsk_ExeclusiveWaitForPressButton();
  pCanvas->FillFull(GlobalBGColor15);
}

// ----------------------------------------------------

static void chkdsk_WriteTest_ShowError(void)
{
  CglCanvas *pCanvas=pScreenMain->pCanvas;
  
  pCanvas->FillFull(GlobalBGColor15);
  
  u32 x=8,y=8;
  
  pCanvas->TextOutUTF8(x,y,"ディスクアクセステストに失敗しました。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"・ディスク空き容量が極端に少ない");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"・書き込みに対応していないDLDIドライバ");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"・CF/SDとアダプタの相性、接触不良");
  y+=16;
  pCanvas->TextOutUTF8(x,y,"・ディスク管理エリアが破損している");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"などの原因が考えられます。");
  y+=16;
  y+=16;
  pCanvas->TextOutUTF8(x,y,"安全のため、アプリケーションを停止しました。");
  
  Sound_Start(WAVFN_Notify);
  ShowLogHalt();
}

#define chkdsk_TempFilename "/_CHKDSK_.$$$"

static void chkdsk_WriteTest(void)
{
  {
    CglCanvas *pCanvas=pScreenMain->pCanvas;
    pCanvas->TextOutUTF8(16,chkdsk_MsgOfsY+(16*3),"ディスクの読み書きテストをしています。");
  }
  
  const u32 TestSize=(16*1024)/4;
  u32 *pTestBuf=(u32*)safemalloc(TestSize*4);
  
  if(pTestBuf==NULL){
    _consolePrint("Fatal error. (pTestBuf) Memory overflow.\n");
    ShowLogHalt();
    return;
  }
  
  _consolePrintf("Disk read-write check. [%s] / ",chkdsk_TempFilename);
  
  FAT_FILE *pfile;
  
  _consolePrint("Open file for write. / ");
  pfile=FAT2_fopen_AliasForWrite(chkdsk_TempFilename);
  if(pfile==NULL){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  for(u32 idx=0;idx<TestSize;idx++){
    pTestBuf[idx]=idx;
  }
  
  _consolePrint("File write. / ");
  if(FAT2_fwrite(pTestBuf,4,TestSize,pfile)!=(TestSize*4)){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("Check position. / ");
  if(FAT2_ftell(pfile)!=(TestSize*4)){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("File seek. / ");
  if(FAT2_fseek(pfile,0,SEEK_SET)!=0){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("Check position. / ");
  if(FAT2_ftell(pfile)!=0){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("File close. / ");
  if(FAT2_fclose(pfile)==false){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  for(u32 idx=0;idx<TestSize;idx++){
    pTestBuf[idx]=0;
  }
  
  _consolePrint("Open file for read. / ");
  pfile=FAT2_fopen_AliasForRead(chkdsk_TempFilename);
  if(pfile==NULL){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("File read. / ");
  if(FAT2_fread(pTestBuf,4,TestSize,pfile)!=(TestSize*4)){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("Check position. / ");
  if(FAT2_ftell(pfile)!=(TestSize*4)){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("Check values. / ");
  for(u32 idx=0;idx<TestSize;idx++){
    if(pTestBuf[idx]!=idx){
      chkdsk_WriteTest_ShowError();
      return;
    }
  }
  
  _consolePrint("File close. / ");
  if(FAT2_fclose(pfile)==false){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("Remove file. / ");
  if(FAT2_remove(chkdsk_TempFilename)!=0){
    chkdsk_WriteTest_ShowError();
    return;
  }
  
  _consolePrint("Succeeded.\n");
  
  safefree(pTestBuf);
}

// ----------------------------------------------------

